﻿using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TilePanelComboScroll
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraCombo1.TextChanged += UltraCombo1_TextChanged;

            string[] alphabet = "A;B;C;D;E;F;G;H;I;J;K;L;M;N;O;P;Q;R;S;T;U;V;W;X;Y;Z".Split(';');

            List<string> items = new List<string>();

            for(int i=0; i<alphabet.Length; i++)
            {
                string letter = alphabet[i];

                for(int j=0; j<alphabet.Length; j++)
                {
                    items.Add(letter + alphabet[j]);
                }
            }

            ultraCombo1.DataSource = items;
            ultraCombo1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.Append;

            ultraTilePanel1.MaximumColumns = 4;
            
            for(int i=0; i<items.Count; i++)
            {
                UltraTile tile = new UltraTile(items[i]);
                tile.Control = new Label() { Text = "This is the tile for item " + items[i] };
                ultraTilePanel1.Tiles.Add(tile);                
            }

            ultraTilePanel1.Visible = true;
        }

        private void UltraCombo1_TextChanged(object sender, EventArgs e)
        {
            string text = ultraCombo1.Text;

            UltraTile tile = ultraTilePanel1.Tiles.Where(t => t.Caption.Contains(text)).FirstOrDefault();

            var tilePoint = tile.PointToScreen(this.Location);            

            TileContainerPanel panel = ultraTilePanel1.Controls[0] as TileContainerPanel;

            // This is here because if the tile point Y is less than 0, we are scrolling upward with the ScrollControlIntoView call
            // If we are scrolling downward, the tile will be at the bottom, so we are suspending the layout and then scrolling the last tile into view to ensure
            // that we are scrolling upward. Then resume the layout to prevent any "flicker" of the scroll down.
            if(tilePoint.Y < 0)
            {
                panel.ScrollControlIntoView(tile);
            }
            else
            {
                panel.SuspendLayout();

                panel.ScrollControlIntoView(ultraTilePanel1.Tiles.Last());
                panel.ScrollControlIntoView(tile);

                panel.ResumeLayout();
            }            
        }
    }
}
